defmodule DecentralisedBookIndex.Sync.DataTransformers.AuthorTransformer do
  def from_json(json_body) do
    json_body =
      if Map.has_key?(json_body, "data") do
        json_body["data"]
      else
        json_body
      end

    attrs =
      %{
        id: get_in(json_body, ["id"]),
        name: get_in(json_body, ["attributes", "name"]),
        description: get_in(json_body, ["attributes", "description"]),
        avatar_url: get_in(json_body, ["attributes", "avatar_url"]),
        author_alias_registry_id: get_in(json_body, ["attributes", "author_alias_registry_id"]),
      }

    {:ok, attrs}
  end
end
