defmodule DecentralisedBookIndex.Sync.BookEditionsRegistrySync do
  alias DecentralisedBookIndex.Metadata
  alias DecentralisedBookIndex.Metadata.BookEditionsRegistry

  def create_update(attrs, server_id) do
    case Metadata.get_book_editions_registry_by_id(attrs.id) do
      {:ok, editions_registry} ->
        attrs =
          attrs
          |> Map.delete(:id)
          |> Map.put(:dbi_server_id, server_id)

        editions_registry
        |> Ash.Changeset.for_update(:sync, attrs)
        |> Ash.update!(authorize?: false)

        :ok

      {:error, %Ash.Error.Query.NotFound{}} ->
        attrs =
          attrs
          |> Map.put(:dbi_server_id, server_id)

        BookEditionsRegistry
        |> Ash.Changeset.for_create(:sync_create, attrs)
        |> Ash.create!(authorize?: false)

        :ok
    end
  end
end
