defmodule DecentralisedBookIndex.Sync.PublisherSync do
  alias DecentralisedBookIndex.Metadata
  alias DecentralisedBookIndex.Metadata.Publisher

  def create_update(attrs, server_id) do
    case Metadata.get_publisher_by_id(attrs.id) do
      {:ok, publisher} ->
        attrs =
          attrs
          |> Map.delete(:id)
          |> Map.put(:dbi_server_id, server_id)

        publisher
        |> Ash.Changeset.for_update(:sync, attrs)
        |> Ash.update!(authorize?: false)

        :ok
      {:error, %Ash.Error.Query.NotFound{}} ->
        attrs =
          attrs
          |> Map.put(:dbi_server_id, server_id)

        Publisher
        |> Ash.Changeset.for_create(:sync_create, attrs)
        |> Ash.create!(authorize?: false)

        :ok
    end
  end
end
