defmodule DecentralisedBookIndexWeb.DbiServerLive.Show do
  use DecentralisedBookIndexWeb, :live_view

  @impl true
  def render(assigns) do
    ~H"""
    <.header class="flex-col lg:flex-row">
      {@dbi_server.name}

      <:actions>
        <.link patch={~p"/servers/#{@dbi_server}/edit"} phx-click={JS.push_focus()}>
          <.edit_button>
            Edit
          </.edit_button>
        </.link>
      </:actions>
    </.header>

    <.list>
      <:item title="Id">{@dbi_server.id}</:item>

      <:item title="Name">{@dbi_server.name}</:item>

      <:item title="Url">{@dbi_server.url}</:item>
    </.list>

    <.back navigate={~p"/servers"}>Back to servers</.back>
    """
  end

  @impl true
  def mount(_params, _session, socket) do
    {:ok, socket}
  end

  @impl true
  def handle_params(%{"id" => id}, _, socket) do
    {:noreply,
     socket
     |> assign(:page_title, page_title(socket.assigns.live_action))
     |> assign(
       :dbi_server,
       Ash.get!(DecentralisedBookIndex.Metadata.DBIServer, id, actor: socket.assigns.current_user)
     )}
  end

  defp page_title(:show), do: "Show server"
  defp page_title(:edit), do: "Edit server"
end
