defmodule DecentralisedBookIndex.Accounts.RoleTest do
  use ExUnit.Case, async: true

  alias DecentralisedBookIndex.Accounts.Role

  @user :user
  @moderator :moderator
  @admin :admin

  describe "can_moderate?" do
    test "user can't moderate" do
      refute Role.can_moderate?(@user)
    end

    test "moderator and admin can moderate" do
      assert Role.can_moderate?(@moderator)
      assert Role.can_moderate?(@admin)
    end
  end

  describe "can_administrate?" do
    test "user and moderator can't administrate" do
      refute Role.can_administrate?(@user)
      refute Role.can_administrate?(@moderator)
    end

    test "admin can administrate" do
      assert Role.can_administrate?(@admin)
    end
  end
end
